from ..interfaces import FriendlyEntity
from ..translations import gettext as _
from .player import Player
from .items import Item
from random import choice


class Merchant(FriendlyEntity) :
    """
    The class for merchants in the dungeon
    """
    inventory = list
    hazel = int
    
    def keys(self) -> list:
        """
        Returns a friendly entitie's specific attributes
        """
        return ["maxhealth", "health", "inventory", "hazel"]

    def __init__(self, name : str = "merchant", hazel : int = 75):
        super().__init__(name = name)
        self.hazel = hazel
        self.name = name
        self.inventory = []
        for i in range(5) :
            self.inventory.append(choice(Item.get_all_items())())

    def talk_to(self, player : Player) -> str:
        """
        This function is used to open the merchant's inventory in a menu,
        and allow the player to buy/sell objects
        """
        # TODO
        
class Sunflower(FriendlyEntity) :
    """
    A friendly sunflower
    """
    dialogue_option = [_("Flower power!!"), _("The sun is warm today")]
    
    def __init__(self, maxhealth: int = 15,
                 *args, **kwargs) -> None:
        super().__init__(name="sunflower",
                         maxhealth=maxhealth, *args, **kwargs)
